#include <reg52.h>
#include <intrins.h>

#define uchar unsigned char

unsigned char code table[] = {
	0x3f,0x06,0x5b,0x4f,
	0x66,0x6d,0x7d,0x07,
	0x7f,0x6f,0x77,0x7c,
	0x39,0x5e,0x79,0x71	};

sbit u1 = P3 ^ 0;//һʾʾֵ
sbit u2 = P3 ^ 1;//ڶʾʾڵڼ
sbit ad_cs = P3 ^ 2;//ADоƬCS
sbit ad_read = P3 ^ 3; //ADоƬRD
sbit ad_write = P3 ^ 4;//ADоƬWR

void show_dig(uchar num,uchar index,bit dot);
void delay(uchar ms);
void show(float num);

void main()
{
	uchar val = 0;
	//ADоƬ
	ad_cs = 0;
	while(1)
	{
		//ad_write = 1;
		//_nop_();
		ad_write = 0;
		_nop_();
		ad_write = 1;
		delay(50);
		P1 = 0xff;
		//ad_read = 1;
		//_nop_();
		ad_read = 0;
		_nop_();
		val = P1;
		ad_read = 1;
		show((val>>4)*0.32 + (val&0x0f)*0.02);
	}		
}

//ʱ
void delay(uchar ms)
{
	uchar i,j;
	for(i=0;i<ms;i++)
	{
		for(j=0;j<110;j++)
			;
	}
}

//ʾ֣numҪʾ֣indexҪʾλãdotǷʾС
void show_dig(uchar num,uchar index,bit dot)
{
	u2 = 1;
	P2 = ~(1 << index);
	u2 = 0;

	u1 = 1;
	if(num>9)
		P2 = 0x0;
	else
		P2 = dot==1?(0x80|table[num]):table[num];

	u1 = 0;
	P2 = 0xff;
}

//ʾ֣Сλ
void show(float num)
{	  
	uchar i;
	unsigned long val = num * 1000;//ʾС3λ
	bit flag = 1;//λظʾ
	//ұߵܿʼʾλʾ
	for(i=6; i>0; i--)
	{
		if((val>0) && (flag==1))
		{
			show_dig(val%10,i,i==3);
			val /= 10;
		}

		if((i<4) && (val==0))
		{
			flag = 0;
		}

		delay(2);
	}
}